#!/usr/bin/perl -w
use strict;

#####

my $chr = 'ChrX';
my $LocusName = 'yellow';  #A name for your output file(s)
my $PosStart = 235001;  #The first reference genome position to include in your file(s)
my $PosStop = 265000;  #The last reference genome position to include in your file(s)
my $RevComp = 'No';  #Reverse complement the output files?  'Yes' or 'No'
my $SingleOutputFile = 'Yes';  #Set to 'Yes' for a single multi-individual FastA file.  Set to 'No' to create a separate FastA file for each individual

#Reduce the list below to the genomes you want data from
my @InLines = ('13_29', '13_34', '20_17', '20_28', '21_36', '21_39', '24_2', '24_9', '28_8', '33_11', '33_16', '36_12', '36_9', '4_12', '4_27', '40_10', '40_23', '42_20', '42_23', '43_18', '43_19', 'B04', 'B05', 'b1', 'B10', 'B11', 'B12', 'B14', 'B23', 'B28', 'B38', 'b3839', 'b3841', 'b3841ST', 'b3844', 'b3846', 'b3852', 'b3864', 'b3870', 'b3875', 'b3886', 'B42', 'B43', 'B51', 'B52', 'B54', 'B59', 'CK1', 'CK2', 'CO1', 'CO10b-3', 'CO10N', 'CO13N', 'CO14', 'CO15N', 'CO16', 'CO16-3', 'CO2', 'CO4N', 'CO8b-3', 'CO8N', 'CO9N', 'EA103N', 'EA117N', 'EA119', 'EA124N', 'EA126N', 'EA13N', 'EA22N', 'EA2N', 'EA3', 'EA30N', 'EA31N', 'EA37N', 'EA49', 'EA50N', 'EA58N', 'EA59N', 'EA70N', 'EA71', 'EA84N', 'EA86N', 'EA87', 'EA87N', 'EA90N', 'EA91N', 'EA93N', 'EB132', 'EB148', 'EB18', 'EB237', 'EB25', 'ED10N', 'ED19-1-3', 'ED2', 'ED3', 'ED55-2', 'ED56-2', 'ED5N', 'ED6N', 'EF101N', 'EF102N', 'EF103N', 'EF108N', 'EF10N', 'EF110N', 'EF112N', 'EF114N', 'EF115N', 'EF116N', 'EF117N', 'EF119N', 'EF11N', 'EF120', 'EF120N', 'EF122N', 'EF126N', 'EF12N', 'EF130N', 'EF131N', 'EF132N', 'EF134N', 'EF135N', 'EF136N', 'EF15N', 'EF16N', 'EF19N', 'EF1N', 'EF2', 'EF24N', 'EF25N', 'EF26N', 'EF27N', 'EF31N', 'EF32N', 'EF35N', 'EF39', 'EF3N', 'EF43N', 'EF46N', 'EF48N', 'EF52N', 'EF53N', 'EF54N', 'EF59N', 'EF64N', 'EF65', 'EF66N', 'EF67N', 'EF69N', 'EF6N', 'EF70N', 'EF73N', 'EF74N', 'EF75N', 'EF78', 'EF7N', 'EF80N', 'EF81N', 'EF82N', 'EF83N', 'EF86N', 'EF88N', 'EF8N', 'EF93N', 'EF95N', 'EF96N', 'EF98N', 'EF9N', 'EG12N', 'EG15N', 'EG16N', 'EG25N', 'EG26N', 'EG28N', 'EG29N', 'EG31N', 'EG33N', 'EG34N', 'EG35N', 'EG36N', 'EG38N', 'EG40N', 'EG44N', 'EG46N', 'EG48N', 'EG49N', 'EG50N', 'EG53N', 'EG54N', 'EG55N', 'EG57N', 'EG58N', 'EG59N', 'EG65N', 'EG69N', 'EG70N', 'EG73N', 'EG74N', 'EG75N', 'EG76N', 'EM239', 'EM40', 'EM6', 'ER11', 'ER156', 'ER32', 'ER63', 'ER85', 'EZ2', 'EZ25', 'EZ5N', 'EZ63-1-3', 'EZ9N', 'FR106N', 'FR109N', 'FR110N', 'FR112N', 'FR113N', 'FR115N', 'FR11N', 'FR126N', 'FR12N', 'FR135N', 'FR14', 'FR147N', 'FR151', 'FR152N', 'FR153N', 'FR157N', 'FR158N', 'FR161N', 'FR162N', 'FR164N', 'FR169N', 'FR16N', 'FR173N', 'FR180', 'FR186N', 'FR188N', 'FR198N', 'FR19N', 'FR200N', 'FR207', 'FR208N', 'FR213N', 'FR216N', 'FR217', 'FR219N', 'FR21N', 'FR222N', 'FR225N', 'FR229', 'FR230N', 'FR231N', 'FR232N', 'FR235N', 'FR236N', 'FR238N', 'FR240N', 'FR248N', 'FR252N', 'FR257N', 'FR260N', 'FR261N', 'FR263N', 'FR264N', 'FR269N', 'FR26N', 'FR276N', 'FR279N', 'FR284N', 'FR288N', 'FR28N', 'FR293N', 'FR296N', 'FR299N', 'FR2N', 'FR302N', 'FR304N', 'FR305N', 'FR310', 'FR312N', 'FR313N', 'FR319N', 'FR320N', 'FR323N', 'FR326N', 'FR32N', 'FR340N', 'FR345N', 'FR348N', 'FR34N', 'FR357N', 'FR360N', 'FR361', 'FR364N', 'FR370N', 'FR37N', 'FR48N', 'FR54N', 'FR59N', 'FR5N', 'FR60N', 'FR70', 'FR73N', 'FR89N', 'FR90N', 'FR91N', 'FR94N', 'GA125', 'GA129', 'GA130', 'GA132', 'GA141', 'GA145', 'GA160', 'GA185', 'GA187', 'GA191', 'GU10', 'GU11-3', 'GU2', 'GU3-3', 'GU6', 'GU7', 'GU9', 'H_25', 'H_29', 'I01', 'I02', 'I03', 'I04', 'I06', 'I07', 'I13', 'I16', 'I17', 'I22', 'I23', 'I24', 'I26', 'I29', 'I31', 'I33', 'I34', 'I35', 'I38', 'KM106', 'KM36', 'KM73', 'KM92', 'KN133N', 'KN20N', 'KN34', 'KN35', 'KN6', 'KN73-1-3', 'KO10-1-3', 'KO2-1-3', 'KO6-1-3', 'KR39', 'KR42', 'KR4N', 'KR54-1-3', 'KR68-1-3', 'KR7', 'KT1', 'KT6', 'MW11-1', 'MW27-3', 'MW28-1', 'MW28-2-3', 'MW38-1', 'MW38-2', 'MW46-1', 'MW56-2-3', 'MW6-1', 'MW6-2', 'MW6-3', 'MW63-1', 'MW63-2-3', 'MW9-1', 'MW9-2', 'N01', 'N02', 'N03', 'N04', 'N07', 'N10', 'N11', 'N13', 'N14', 'N15', 'N16', 'N17', 'N18', 'N19', 'N22', 'N23', 'N25', 'N29', 'N30', 'NG10N', 'NG1N', 'NG3N', 'NG6N', 'NG7', 'NG9', 'RAL-100', 'RAL-101', 'RAL-105', 'RAL-109', 'RAL-129', 'RAL-136', 'RAL-138', 'RAL-142', 'RAL-149', 'RAL-153', 'RAL-158', 'RAL-161', 'RAL-176', 'RAL-177', 'RAL-181', 'RAL-189', 'RAL-195', 'RAL-208', 'RAL-21', 'RAL-217', 'RAL-223', 'RAL-227', 'RAL-228', 'RAL-229', 'RAL-233', 'RAL-235', 'RAL-237', 'RAL-239', 'RAL-256', 'RAL-26', 'RAL-28', 'RAL-280', 'RAL-287', 'RAL-301', 'RAL-303', 'RAL-304', 'RAL-306', 'RAL-307', 'RAL-309', 'RAL-31', 'RAL-310', 'RAL-313', 'RAL-315', 'RAL-317', 'RAL-318', 'RAL-319', 'RAL-32', 'RAL-320', 'RAL-321', 'RAL-324', 'RAL-325', 'RAL-332', 'RAL-335', 'RAL-336', 'RAL-338', 'RAL-340', 'RAL-348', 'RAL-350', 'RAL-352', 'RAL-354', 'RAL-355', 'RAL-356', 'RAL-357', 'RAL-358', 'RAL-359', 'RAL-360', 'RAL-361', 'RAL-362', 'RAL-365', 'RAL-367', 'RAL-370', 'RAL-371', 'RAL-373', 'RAL-374', 'RAL-375', 'RAL-377', 'RAL-379', 'RAL-38', 'RAL-380', 'RAL-381', 'RAL-382', 'RAL-383', 'RAL-385', 'RAL-386', 'RAL-390', 'RAL-391', 'RAL-392', 'RAL-395', 'RAL-397', 'RAL-399', 'RAL-40', 'RAL-405', 'RAL-406', 'RAL-409', 'RAL-41', 'RAL-42', 'RAL-426', 'RAL-427', 'RAL-437', 'RAL-439', 'RAL-440', 'RAL-441', 'RAL-443', 'RAL-45', 'RAL-461', 'RAL-48', 'RAL-486', 'RAL-49', 'RAL-491', 'RAL-492', 'RAL-502', 'RAL-505', 'RAL-508', 'RAL-509', 'RAL-513', 'RAL-517', 'RAL-528', 'RAL-530', 'RAL-531', 'RAL-535', 'RAL-551', 'RAL-555', 'RAL-559', 'RAL-563', 'RAL-566', 'RAL-57', 'RAL-584', 'RAL-589', 'RAL-59', 'RAL-595', 'RAL-596', 'RAL-627', 'RAL-630', 'RAL-634', 'RAL-639', 'RAL-642', 'RAL-646', 'RAL-69', 'RAL-703', 'RAL-705', 'RAL-707', 'RAL-712', 'RAL-714', 'RAL-716', 'RAL-721', 'RAL-727', 'RAL-73', 'RAL-730', 'RAL-732', 'RAL-737', 'RAL-738', 'RAL-748', 'RAL-75', 'RAL-757', 'RAL-761', 'RAL-765', 'RAL-774', 'RAL-776', 'RAL-783', 'RAL-786', 'RAL-787', 'RAL-790', 'RAL-796', 'RAL-799', 'RAL-801', 'RAL-802', 'RAL-804', 'RAL-805', 'RAL-808', 'RAL-810', 'RAL-812', 'RAL-818', 'RAL-819', 'RAL-820', 'RAL-821', 'RAL-822', 'RAL-83', 'RAL-832', 'RAL-837', 'RAL-843', 'RAL-849', 'RAL-85', 'RAL-850', 'RAL-852', 'RAL-853', 'RAL-855', 'RAL-857', 'RAL-859', 'RAL-861', 'RAL-879', 'RAL-88', 'RAL-882', 'RAL-884', 'RAL-887', 'RAL-890', 'RAL-892', 'RAL-894', 'RAL-897', 'RAL-900', 'RAL-907', 'RAL-908', 'RAL-91', 'RAL-911', 'RAL-913', 'RAL-93', 'RC1', 'RC5', 'RG10', 'RG11N', 'RG13N', 'RG15', 'RG18N', 'RG19', 'RG2', 'RG21N', 'RG22', 'RG24', 'RG25', 'RG28', 'RG3', 'RG32N', 'RG33', 'RG34', 'RG35', 'RG36', 'RG37N', 'RG38N', 'RG39', 'RG4N', 'RG5', 'RG6N', 'RG7', 'RG8', 'RG9', 'SAM', 'SB10', 'SB16', 'SB26', 'SB31', 'SB51', 'SD101N', 'SD104N', 'SD105N', 'SD106N', 'SD108N', 'SD109N', 'SD110N', 'SD113N', 'SD114N', 'SD115N', 'SD116N', 'SD117N', 'SD120N', 'SD121N', 'SD124N', 'SD127N', 'SD128N', 'SD130N', 'SD131N', 'SD132N', 'SD133N', 'SD135N', 'SD137N', 'SD138N', 'SD140N', 'SD141N', 'SD142N', 'SD144N', 'SD145', 'SD149N', 'SD14N', 'SD151N', 'SD17N', 'SD18N', 'SD1N', 'SD20N', 'SD21N', 'SD23N', 'SD24N', 'SD25N', 'SD27N', 'SD28N', 'SD29N', 'SD32N', 'SD35N', 'SD37N', 'SD38N', 'SD39N', 'SD3N', 'SD42N', 'SD43N', 'SD44N', 'SD45', 'SD47N', 'SD48N', 'SD49N', 'SD51N', 'SD53N', 'SD54N', 'SD55N', 'SD56N', 'SD59N', 'SD5N', 'SD63N', 'SD64N', 'SD65N', 'SD67', 'SD68N', 'SD71N', 'SD72N', 'SD73N', 'SD77N', 'SD78N', 'SD79N', 'SD82', 'SD88N', 'SD8N', 'SD90N', 'SD92N', 'SD94N', 'SD98', 'SE16', 'SE55', 'SE63', 'SF110', 'SF332', 'SF428', 'SF447', 'SF7', 'SP103N', 'SP107N', 'SP115N', 'SP127N', 'SP133N', 'SP159N', 'SP15N', 'SP173', 'SP175N', 'SP17N', 'SP188', 'SP191N', 'SP19N', 'SP1N', 'SP201N', 'SP213N', 'SP221', 'SP235', 'SP241', 'SP249N', 'SP254', 'SP267N', 'SP279N', 'SP287N', 'SP291N', 'SP315N', 'SP323N', 'SP335N', 'SP347N', 'SP39N', 'SP61N', 'SP69N', 'SP75N', 'SP80', 'SP83N', 'SP87N', 'SP95N', 't0', 'T01', 'T04', 'T05', 'T07', 'T09', 't0XSAM', 't0XSS', 't1', 'T10', 'T14A', 'T22A', 'T23', 'T24', 'T25A', 'T29A', 'T30A', 'T35', 'T36B', 'T39', 't4', 'T43A', 'T45B', 't7', 'TZ10', 'TZ14', 'TZ8', 'UG17-3', 'UG19', 'UG28N', 'UG40-3', 'UG5N', 'UG7', 'UK10', 'UK120', 'UK2', 'UK57', 'UK73', 'UM118', 'UM37', 'UM526', 'w114', 'w23', 'w26', 'w33', 'w34', 'w35', 'w36', 'w37', 'w38', 'w40', 'w43', 'w47', 'w49', 'w50', 'w52', 'w54', 'w55', 'w56', 'w59', 'w60', 'w62', 'w63', 'w64', 'w66', 'w67', 'w68', 'w69', 'w74', 'w76', 'w79', 'w80', 'w82', 'w84', 'w86', 'w87', 'ZH23', 'ZH26', 'ZH33', 'ZH42', 'ZI10', 'ZI103', 'ZI104', 'ZI114N', 'ZI117', 'ZI118N', 'ZI126', 'ZI129', 'ZI134N', 'ZI136', 'ZI138', 'ZI152', 'ZI157', 'ZI161', 'ZI164', 'ZI165', 'ZI167', 'ZI170', 'ZI172', 'ZI173', 'ZI176', 'ZI177', 'ZI178', 'ZI179', 'ZI181', 'ZI182', 'ZI184', 'ZI185', 'ZI188', 'ZI190', 'ZI191', 'ZI193', 'ZI194', 'ZI196', 'ZI197N', 'ZI198', 'ZI199', 'ZI200', 'ZI202', 'ZI206', 'ZI207', 'ZI210', 'ZI211', 'ZI212', 'ZI213', 'ZI214', 'ZI216N', 'ZI218', 'ZI219', 'ZI220', 'ZI221', 'ZI225', 'ZI226', 'ZI227', 'ZI228', 'ZI230', 'ZI231', 'ZI232', 'ZI233', 'ZI235', 'ZI237', 'ZI239', 'ZI240', 'ZI241', 'ZI250', 'ZI251N', 'ZI252', 'ZI253', 'ZI254N', 'ZI255', 'ZI26', 'ZI261', 'ZI263', 'ZI264', 'ZI265', 'ZI267', 'ZI268', 'ZI269', 'ZI27', 'ZI271', 'ZI273N', 'ZI276', 'ZI279', 'ZI28', 'ZI281', 'ZI284', 'ZI286', 'ZI291', 'ZI292', 'ZI293', 'ZI295', 'ZI296', 'ZI303', 'ZI311N', 'ZI313', 'ZI314', 'ZI316', 'ZI317', 'ZI319', 'ZI31N', 'ZI320', 'ZI321', 'ZI324', 'ZI329', 'ZI33', 'ZI332', 'ZI333', 'ZI335', 'ZI336', 'ZI339', 'ZI341', 'ZI342', 'ZI344', 'ZI348', 'ZI351', 'ZI352', 'ZI353', 'ZI357N', 'ZI358', 'ZI359', 'ZI362', 'ZI364', 'ZI365', 'ZI368', 'ZI370', 'ZI373', 'ZI374', 'ZI377', 'ZI378', 'ZI379', 'ZI380', 'ZI381', 'ZI382', 'ZI384', 'ZI386', 'ZI388', 'ZI392', 'ZI394N', 'ZI395', 'ZI396', 'ZI397N', 'ZI398', 'ZI400', 'ZI402', 'ZI405', 'ZI413', 'ZI418N', 'ZI420', 'ZI421', 'ZI429', 'ZI431', 'ZI433', 'ZI437', 'ZI443', 'ZI444', 'ZI445', 'ZI446', 'ZI447', 'ZI448', 'ZI453', 'ZI455N', 'ZI456', 'ZI457', 'ZI458', 'ZI460', 'ZI466', 'ZI467', 'ZI468', 'ZI471', 'ZI472', 'ZI476', 'ZI477', 'ZI486', 'ZI488', 'ZI490', 'ZI491', 'ZI504', 'ZI505', 'ZI508', 'ZI50N', 'ZI514N', 'ZI517', 'ZI523', 'ZI524', 'ZI527', 'ZI530', 'ZI56', 'ZI59', 'ZI61', 'ZI68', 'ZI76', 'ZI81', 'ZI85', 'ZI86', 'ZI90', 'ZI91', 'ZI99', 'ZK131', 'ZK186', 'ZK84', 'ZL130', 'ZO12', 'ZO65', 'ZS10', 'ZS11', 'ZS37', 'ZS5', 'ZS56', 'ZW09', 'ZW139', 'ZW140', 'ZW142', 'ZW144', 'ZW155', 'ZW177', 'ZW184', 'ZW185');




#declarations
my $file = '';
my $unmask = '';
my $noadfilt = '';
my $OutputFile = '';
my $OutputName = '';
my $RangeStart = 0;
my $RangeStop = 0;
my @LineSeq = ();
my @InputSeq = ();
my @OutputSeq = ();
my $i = 0;
my $KiloRange = 0;
my $WinStart = -1;
my $f = 0;

#If single output file, have this output file open
if ($SingleOutputFile eq 'Yes'){
 $OutputFile = $LocusName . '_' . $chr;
    if ($RevComp eq 'Yes'){
      $OutputFile = $OutputFile . '_' . $PosStop . '_' . $PosStart . '.fas';
    }
    else{
      $OutputFile = $OutputFile . '_' . $PosStart . '_' . $PosStop . '.fas';
    }
  open M, ">$OutputFile";
}

#Cycle through each genome, opening file, then scanning through 1kb blocks to find the region of interest
for ($f = 0; $f < @InLines; $f++){
  $file = $InLines[$f] . "_" . $chr . "\.seq1k";
  unless (-e $file) {
    print "Can't open $file (maybe this genome doesn't have data for this chromosome).\n";
    next;
  }
  open I, "<$file";
  @InputSeq = ();
  @OutputSeq = ();
  $KiloRange = 0;
  $WinStart = -1;

  while (<I>){
    chomp;
    if ($PosStart <= $KiloRange + 1000){
      if ($WinStart < 0){
	$WinStart = $KiloRange;
      }
      @LineSeq = split(//, $_);
      @InputSeq = (@InputSeq, @LineSeq);
      last if ($PosStop <= $KiloRange + 1000);
    }
    $KiloRange += 1000;
  }
  close I;

  $RangeStart = $PosStart - $WinStart;
  $RangeStop = $PosStop - $WinStart;

  if ($RevComp eq 'Yes'){
    for ($i = ($RangeStop - 1); $i >= ($RangeStart - 1); $i--){
      if ($InputSeq[$i] eq 'A'){
	push @OutputSeq, 'T';
      }
      elsif ($InputSeq[$i] eq 'C'){
	push @OutputSeq, 'G';
      }
      elsif ($InputSeq[$i] eq 'G'){
	push @OutputSeq, 'C';
      }
      elsif ($InputSeq[$i] eq 'T'){
	push @OutputSeq, 'A';
      }
      else{
	push @OutputSeq, 'N';
      }
    }
  }
  else{
    for ($i = ($RangeStart - 1); $i < $RangeStop; $i++){
      push @OutputSeq, $InputSeq[$i];
    }
  }

#output
  if ($SingleOutputFile eq 'Yes'){
    $OutputName = '>' . $InLines[$f];
    print M "$OutputName\n";
    for ($i = 0; $i < @OutputSeq; $i++){
      print M $OutputSeq[$i];
      #uncomment the lines below to add line breaks every 1000 bp
      #    if ($i % 1000 == 999){
      #      print O "\n";
      #    }
    }
    print M "\n";
  }

  else{
    $OutputFile = $LocusName . '_' . $InLines[$f] . '_' . $chr;
    if ($RevComp eq 'Yes'){
      $OutputFile = $OutputFile . '_' . $PosStop . '_' . $PosStart . '.fas';
    }
    else{
      $OutputFile = $OutputFile . '_' . $PosStart . '_' . $PosStop . '.fas';
    }
    $OutputName = '>' . $InLines[$f];
    open O, ">$OutputFile";
    print O "$OutputName\n";
    for ($i = 0; $i < @OutputSeq; $i++){
      print O $OutputSeq[$i];
      #uncomment the lines below to add line breaks every 1000 bp
      #    if ($i % 1000 == 999){
      #      print O "\n";
      #    }
    }
  }
}
